<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:external="http://www.seapine.com" exclude-result-prefixes="external" id="TT V5.0 ReportDetailReport.xslt">

	<xsl:output method="html" version="4.0" encoding="iso-8859-1" indent="yes" />

	<!-- Indicates whether empty fields should be displayed in the report -->
	<xsl:param name="DisplayEmptyFields" select="true()" />

	<!-- Contains the default settings for the report title page header table -->
	<xsl:attribute-set name="pageheader-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">0</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report header image -->
	<xsl:attribute-set name="report-header-image">
		<xsl:attribute name="src">
			<xsl:value-of select="external:get-server-image('seapinelogo.jpg')" disable-output-escaping = "yes" />
		</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the image on the report title page header -->
	<xsl:attribute-set name="report-header-image-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ReportTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report title on the report title page header -->
	<xsl:attribute-set name="report-header-title-format">
		<xsl:attribute name="align">right</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ReportTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the defect header rows table -->
	<xsl:attribute-set name="header-row-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">2</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the defect header rows cells -->
	<xsl:attribute-set name="header-row-cell-format">
		<xsl:attribute name="width">50%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">HeaderRowClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail  tables -->
	<xsl:attribute-set name="report-detail-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">0</xsl:attribute>
		<xsl:attribute name="cellspacing">3</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail title cells -->
	<xsl:attribute-set name="report-title-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail title cells -->
	<xsl:attribute-set name="report-detail-title-format">
		<xsl:attribute name="width">15%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail title cells -->
	<xsl:attribute-set name="report-detail-data-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowDataClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail description title cells -->
	<xsl:attribute-set name="report-detail-descriptiontitle-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the description cell -->
	<xsl:attribute-set name="report-detail-description-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowDataClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail title cells -->
	<xsl:attribute-set name="report-members-title-format">
		<xsl:attribute name="width">15%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the description cell -->
	<xsl:attribute-set name="report-members-data-format">
		<xsl:attribute name="width">25%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowDataClass</xsl:attribute>
	</xsl:attribute-set>

	<xsl:template name="DefineStyles">
		<STYLE>  
		 		.ReportTitleClass	
		 		{
					FONT-FAMILY: 'serif';
					FONT-SIZE: 30px;
					COLOR: #2B558A;
					FONT-WEIGHT:bold;
				}
	      </STYLE>
		<STYLE>  
		 		.HeaderRowClass
				{
					font-family: Verdana, Arial, Helvetica, sans-serif;
					font-size: 11px;
					color: white;
					font-weight:bold;
					text-align: left;
					background-color:  #2B558A;
				}
	      </STYLE>
		<STYLE>  
		 		.DetailRowTitleClass
				{
					font-family: Verdana, Arial, Helvetica, sans-serif;
					font-size: 10px;
					color: black;
					font-weight:bold;
					text-align: left;
					background-color:  white;
				}
	      </STYLE>
		<STYLE>  
		 		.DetailRowDataClass
				{
					font-family: Verdana, Arial, Helvetica, sans-serif;
					font-size: 10px;
					color: black;
					font-weight:normal;
					text-align: left;
					background-color:  white;
				}
	      </STYLE>
	</xsl:template>

	<!-- Displays a user's name in the proper format -->
	<xsl:template name="display_user_name">
		<xsl:if test="(string-length(last-name) = 0) and (string-length(first-name) = 0)">
      			Unknown
      		</xsl:if>
		<xsl:if test="(string-length(last-name) > 0)">
			<xsl:value-of select="last-name" disable-output-escaping = "yes" />
			<xsl:if test="(string-length(first-name) > 0)">, </xsl:if>
		</xsl:if>
		<xsl:if test=" (string-length(first-name) > 0)">
			<xsl:value-of select="first-name" disable-output-escaping = "yes" />
		</xsl:if>
	</xsl:template>

	<!-- Outputs the Report Header -->
	<xsl:template name="pageheader">
		<table xsl:use-attribute-sets="defect-pageheader-table-format">
			<tr>
				<td xsl:use-attribute-sets="report-header-image-format">
					<img xsl:use-attribute-sets="report-header-image" />
				</td>
				<td xsl:use-attribute-sets="report-header-title-format">
					<xsl:apply-templates select="ancestor-or-self::TestTrackData/Title" />
				</td>
			</tr>
		</table>
	</xsl:template>

	<!-- Displays the report header row -->
	<xsl:template name="detail_report_header_row">
		<tr>
			<td>
				<table xsl:use-attribute-sets="header-row-table-format">
					<tr>
						<td xsl:use-attribute-sets="header-row-cell-format">
							<xsl:value-of select="name/@field-label" disable-output-escaping = "yes" />
							<xsl:value-of select="name" disable-output-escaping = "yes" />
						</td>
						<td xsl:use-attribute-sets="header-row-cell-format">
							<xsl:value-of select="type/@field-label" disable-output-escaping = "yes" />
							<xsl:value-of select="type" disable-output-escaping = "yes" />
						</td>
					</tr>
					<tr>
						<td colspan="2" xsl:use-attribute-sets="report-title-format">
							<xsl:value-of select="title/@field-label" disable-output-escaping = "yes" />
							<span class="DetailRowDataClass">
								<xsl:value-of select="title" disable-output-escaping = "yes" />
							</span>
						</td>
					</tr>
					<tr>
						<td colspan="2" xsl:use-attribute-sets="report-title-format">
							<xsl:value-of select="report_contains/@field-label" disable-output-escaping = "yes" />
							<span class="DetailRowDataClass">
								<xsl:value-of select="report_contains" disable-output-escaping = "yes" />
							</span>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the users in the report -->
	<xsl:template name="detail_report_user_rows">
		<xsl:if test="user">
			<tr>
				<td>
					<table xsl:use-attribute-sets="report-detail-table-format">
						<tr>
							<td colspan="4" xsl:use-attribute-sets="report-members-title-format">
								Users in Report: 
							</td>
						</tr>
						<tr>
							<xsl:for-each select="user">
								<td xsl:use-attribute-sets="report-members-data-format">
									<xsl:for-each select="full-name">
										<xsl:call-template name="display_user_name" />
									</xsl:for-each>
								</td>
								<!-- generate a new row ever 4 columns -->
								<xsl:if test="((position() mod 4) = 0)">
									<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>

	<!-- Displays the customers in the report -->
	<xsl:template name="detail_report_customer_rows">
		<xsl:if test="customer">
			<tr>
				<td>
					<table xsl:use-attribute-sets="report-detail-table-format">
						<tr>
							<td colspan="4" xsl:use-attribute-sets="report-members-title-format">
								Customers in Report:
							</td>
						</tr>
						<tr>
							<xsl:for-each select="customer">
								<td xsl:use-attribute-sets="report-members-data-format">
									<xsl:for-each select="full-name">
										<xsl:call-template name="display_user_name" />
									</xsl:for-each>
								</td>
								<!-- generate a new row ever 4 columns -->
								<xsl:if test="((position() mod 4) = 0)">
									<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>

	<!-- Displays the test configs in the report -->
	<xsl:template name="detail_report_testconfig_rows">
		<xsl:if test="test-config">
			<tr>
				<td>
					<table xsl:use-attribute-sets="report-detail-table-format">
						<tr>
							<td colspan="4" xsl:use-attribute-sets="report-members-title-format">
								Systems included in report:
							</td>
						</tr>
						<tr>
							<xsl:for-each select="test-config">
								<xsl:for-each select="name">
									<td xsl:use-attribute-sets="report-members-data-format">
										<xsl:apply-templates />
									</td>
									<!-- generate a new row ever 4 columns -->
									<xsl:if test="((position() mod 4) = 0)">
										<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
									</xsl:if>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>

	<!-- Displays the user groups in the report -->
	<xsl:template name="detail_report_usergroups_rows">
		<xsl:if test="user_group">
			<tr>
				<td>
					<table xsl:use-attribute-sets="report-detail-table-format">
						<tr>
							<td colspan="4" xsl:use-attribute-sets="report-members-title-format">
								User groups included in report: 
							</td>
						</tr>
						<tr>
							<xsl:for-each select="user_group">
								<td xsl:use-attribute-sets="report-members-data-format">
									<xsl:value-of select="name" disable-output-escaping = "yes" />
								</td>
								<!-- generate a new row ever 4 columns -->
								<xsl:if test="((position() mod 4) = 0)">
									<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>

	<!-- Displays the user fields included in the report -->
	<xsl:template name="detail_report_field_rows">
		<xsl:if test="field">
			<tr>
				<td>
					<table xsl:use-attribute-sets="report-detail-table-format">
						<tr>
							<td colspan="4" xsl:use-attribute-sets="report-members-title-format">
								Fields included in report: 
							</td>
						</tr>
						<tr>
							<xsl:for-each select="field">
								<td xsl:use-attribute-sets="report-members-data-format">
									<xsl:apply-templates />
								</td>
								<!-- generate a new row ever 4 columns -->
								<xsl:if test="((position() mod 4) = 0)">
									<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>

	<!-- Displays the filter defined in the report -->
	<xsl:template name="detail_report_options_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<xsl:if test="report_period">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">
								<xsl:value-of select="report_period/@field-label" disable-output-escaping = "yes" />
							</td>
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="report_period" disable-output-escaping = "yes" />
							</td>
						</tr>
					</xsl:if>
					<tr>
						<td xsl:use-attribute-sets="report-detail-title-format">
							Filter Name: 
						</td>
						<td xsl:use-attribute-sets="report-detail-data-format">
							<xsl:value-of select="filter/name" disable-output-escaping = "yes" />
						</td>
					</tr>
					<tr>
						<td xsl:use-attribute-sets="report-detail-title-format">
							Stylesheet: 
						</td>
						<td xsl:use-attribute-sets="report-detail-data-format">
							<xsl:value-of select="stylesheet" disable-output-escaping = "yes" />
						</td>
					</tr>
					<tr>
						<td xsl:use-attribute-sets="report-detail-title-format">Sort By: </td>
						<td xsl:use-attribute-sets="report-detail-data-format" />
					</tr>
					<xsl:for-each select="sort_order">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format" />
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="order" disable-output-escaping = "yes" /> Field: [<xsl:value-of select="field" disable-output-escaping = "yes" />]
								Direction: [<xsl:value-of select="direction" disable-output-escaping = "yes" />]
							</td>
						</tr>
					</xsl:for-each>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the flags defined in the report -->
	<xsl:template name="detail_report_flag_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<xsl:if test="page_break">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">
								<xsl:value-of select="page_break/@field-label" disable-output-escaping = "yes" />
							</td>
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="page_break" disable-output-escaping = "yes" />
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="grid_lines">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">
								<xsl:value-of select="grid_lines/@field-label" disable-output-escaping = "yes" />
							</td>
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="grid_lines" disable-output-escaping = "yes" />
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="include_totals">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">
								<xsl:value-of select="include_totals/@field-label" disable-output-escaping = "yes" />
							</td>
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="include_totals" disable-output-escaping = "yes" />
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="include_all_status_events">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">
								<xsl:value-of select="include_all_status_events/@field-label" disable-output-escaping = "yes" />
							</td>
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="include_all_status_events" disable-output-escaping = "yes" />
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="include_total_open_defects">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">
								<xsl:value-of select="include_total_open_defects/@field-label" disable-output-escaping = "yes" />
							</td>
							<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="include_total_open_defects" disable-output-escaping = "yes" />
							</td>
						</tr>
					</xsl:if>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Todo priority row for workbook Detail Report XML Parsing -->
	<xsl:template name="detail_report_chart_rows">
		<xsl:if test="chart">
			<tr>
				<td>
					<table xsl:use-attribute-sets="report-detail-table-format">
						<tr>
							<td xsl:use-attribute-sets="report-detail-title-format">Charts: </td>
							<td xsl:use-attribute-sets="report-detail-data-format" />
						</tr>
						<xsl:for-each select="chart">
							<tr>
								<td xsl:use-attribute-sets="report-detail-title-format" />
								<td xsl:use-attribute-sets="report-detail-data-format">
								<xsl:value-of select="chart_title/@field-label" disable-output-escaping = "yes" />				
								 [<xsl:value-of select="chart_title" disable-output-escaping = "yes" />] 
								<xsl:value-of select="chart_type/@field-label" disable-output-escaping = "yes" />				
								[<xsl:value-of select="chart_type" disable-output-escaping = "yes" />] 
								Data to Chart: [			
									<xsl:for-each select="data_provider">
										<xsl:apply-templates />
										<xsl:if test="position()!=last()">
										, 
										</xsl:if>
									</xsl:for-each>
								] 
							</td>
							</tr>
						</xsl:for-each>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>

	<!-- todo Detail Report XML Parsing -->
	<xsl:template name="report">
		<xsl:for-each select="report">
			<table border="1" frame="above" width="100%">
				<xsl:call-template name="detail_report_header_row" />
				<xsl:call-template name="detail_report_user_rows" />
				<xsl:call-template name="detail_report_customer_rows" />
				<xsl:call-template name="detail_report_testconfig_rows" />
				<xsl:call-template name="detail_report_usergroups_rows" />
				<xsl:call-template name="detail_report_field_rows" />
				<xsl:call-template name="detail_report_options_rows" />
				<xsl:call-template name="detail_report_flag_rows" />
				<xsl:call-template name="detail_report_chart_rows" />
			</table>
			<xsl:if test="((ancestor::TestTrackData/include_page_breaks) and (position()!=last()))">
				<DIV style="page-break-after:always"></DIV>
				<xsl:call-template name="pageheader" />
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- Detail Report XML Parsing -->
	<xsl:template match="/">
		<html>
			<head>
				<xsl:call-template name="DefineStyles" />
			</head>
			<body>
				<xsl:for-each select="TestTrackData">
					<xsl:call-template name="pageheader" />
					<xsl:call-template name="report" />
				</xsl:for-each>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>