<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:external="http://www.seapine.com" exclude-result-prefixes="external" id="TT V5.0 UserGroupDetailReport.xslt">

	<xsl:output method="html" version="4.0" encoding="iso-8859-1" indent="yes" />

	<!-- Contains the default settings for the report title page header table -->
	<xsl:attribute-set name="pageheader-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">0</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report header image -->
	<xsl:attribute-set name="report-header-image">
		<xsl:attribute name="src">
			<xsl:value-of select="external:get-server-image('seapinelogo.jpg')" disable-output-escaping = "yes" />
		</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the image on the report title page header -->
	<xsl:attribute-set name="report-header-image-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ReportTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report title on the report title page header -->
	<xsl:attribute-set name="report-header-title-format">
		<xsl:attribute name="align">right</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ReportTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the defect header rows table -->
	<xsl:attribute-set name="header-row-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">2</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the defect header rows cells -->
	<xsl:attribute-set name="header-row-cell-format">
		<xsl:attribute name="width">25%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">HeaderRowClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail title cells -->
	<xsl:attribute-set name="report-users-title-format">
		<xsl:attribute name="width">15%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail  tables -->
	<xsl:attribute-set name="report-detail-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">0</xsl:attribute>
		<xsl:attribute name="cellspacing">3</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail description title cells -->
	<xsl:attribute-set name="report-detail-descriptiontitle-format">
		<xsl:attribute name="width">15%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the description cell -->
	<xsl:attribute-set name="report-detail-description-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowDataClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail description title cells -->
	<xsl:attribute-set name="report-users-title-format">
		<xsl:attribute name="width">33%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the description cell -->
	<xsl:attribute-set name="report-users-data-format">
		<xsl:attribute name="width">33%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowDataClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the report detail description title cells -->
	<xsl:attribute-set name="report-commands-title-format">
		<xsl:attribute name="width">15%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowTitleClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the description cell -->
	<xsl:attribute-set name="report-commands-data-format">
		<xsl:attribute name="width">25%</xsl:attribute>
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">top</xsl:attribute>
		<xsl:attribute name="class">DetailRowDataClass</xsl:attribute>
	</xsl:attribute-set>

	<!-- Defines the default font settings used in the report -->
	<xsl:template name="DefineStyles">
		<!-- Default font settings for the title of the report displayed in the right hand area of the Report Header -->
		<STYLE>  
		 		.ReportTitleClass	{
					FONT-FAMILY: 'serif';
					FONT-SIZE: 30px;
					COLOR: #2B558A;
					FONT-WEIGHT:bold;
					text-align: right;
				}
	      </STYLE>
		<STYLE>  
		 		.HeaderRowClass
				{
					font-family: Verdana, Arial, Helvetica, sans-serif;
					font-size: 11px;
					color: white;
					font-weight:bold;
					text-align: left;
					background-color:  #2B558A;
				}
	      </STYLE>
		<STYLE>  
		 		.DetailRowTitleClass
				{
					font-family: Verdana, Arial, Helvetica, sans-serif;
					font-size: 10px;
					color: black;
					font-weight:bold;
					text-align: left;
					background-color:  white;
				}
	      </STYLE>
		<STYLE>  
		 		.DetailRowDataClass
				{
					font-family: Verdana, Arial, Helvetica, sans-serif;
					font-size: 10px;
					color: black;
					font-weight:normal;
					text-align: left;
					background-color:  white;
				}
	      </STYLE>
	</xsl:template>

	<!-- Displays a user's name in the proper format -->
	<xsl:template name="display_user_name">
		<xsl:if test="(string-length(last-name) = 0) and (string-length(first-name) = 0)">
      			Unknown
      		</xsl:if>
		<xsl:if test="(string-length(last-name) > 0)">
			<xsl:value-of select="last-name" disable-output-escaping = "yes" />
			<xsl:if test="(string-length(first-name) > 0)">, </xsl:if>
		</xsl:if>
		<xsl:if test=" (string-length(first-name) > 0)">
			<xsl:value-of select="first-name" disable-output-escaping = "yes" />
		</xsl:if>
	</xsl:template>

	<!-- Outputs the Report Header -->
	<xsl:template name="pageheader">
		<table xsl:use-attribute-sets="defect-pageheader-table-format">
			<tr>
				<td xsl:use-attribute-sets="report-header-image-format">
					<img xsl:use-attribute-sets="report-header-image" />
				</td>
				<td xsl:use-attribute-sets="report-header-title-format">
					<xsl:apply-templates select="ancestor-or-self::TestTrackData/Title" />
				</td>
			</tr>
		</table>
	</xsl:template>

	<!-- Displays the UserGroup Name row-->
	<xsl:template name="detail_usergroup_header_row">
		<tr>
			<td>
				<table xsl:use-attribute-sets="header-row-table-format">
					<tr>
						<td xsl:use-attribute-sets="header-row-cell-format">
							<xsl:value-of select="name/@field-label" disable-output-escaping = "yes" />
							<xsl:value-of select="name" disable-output-escaping = "yes" />
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the user group description rows for teh report -->
	<xsl:template name="detail_usergroup_detail_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<tr>
						<td xsl:use-attribute-sets="report-detail-descriptiontitle-format">
							<xsl:value-of select="description/@field-label" disable-output-escaping = "yes" />
						</td>
						<td xsl:use-attribute-sets="report-detail-description-format">
								<xsl:value-of select="description" disable-output-escaping = "yes"/>
						</td>
					</tr>
					<tr>
						<td xsl:use-attribute-sets="report-detail-descriptiontitle-format">
							<xsl:value-of select="notes/@field-label" disable-output-escaping = "yes" />
						</td>
						<td xsl:use-attribute-sets="report-detail-description-format">
								<xsl:value-of select="notes" disable-output-escaping = "yes"/>
						</td>
					</tr>
					<tr>
						<td xsl:use-attribute-sets="report-detail-descriptiontitle-format">
							<xsl:value-of select="users_in_popup/@field-label" disable-output-escaping = "yes" />
							<xsl:text></xsl:text>
						</td>
						<td xsl:use-attribute-sets="report-detail-description-format">
							<xsl:value-of select="users_in_popup" disable-output-escaping = "yes" />
						</td>
					</tr>
					<tr>
						<td xsl:use-attribute-sets="report-detail-descriptiontitle-format">
							<xsl:value-of select="customers_in_popup/@field-label" disable-output-escaping = "yes" />
							<xsl:text></xsl:text>
						</td>
						<td xsl:use-attribute-sets="report-detail-description-format">
							<xsl:value-of select="customers_in_popup" disable-output-escaping = "yes" />
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the list of users in the user group. -->
	<xsl:template name="detail_usergroup_user_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<tr>
						<td xsl:use-attribute-sets="report-users-title-format">
							Users in Group:
						</td>
						<td xsl:use-attribute-sets="report-users-title-format" />
						<td xsl:use-attribute-sets="report-users-title-format" />
					</tr>
					<tr>
						<xsl:for-each select="user">
							<td>
								<span xsl:use-attribute-sets="report-users-data-format">
									<xsl:for-each select="full-name">
										<xsl:call-template name="display_user_name" />
									</xsl:for-each>
								</span>
							</td>
							<!-- generate a new row ever 3rd column -->
							<xsl:if test="((position() mod 3) = 0)">
								<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
							</xsl:if>
						</xsl:for-each>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the list of customers in the user group. -->
	<xsl:template name="detail_usergroup_customer_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<tr>
						<td xsl:use-attribute-sets="report-users-title-format">
							Customers in Group:
						</td>
						<td xsl:use-attribute-sets="report-users-title-format" />
						<td xsl:use-attribute-sets="report-users-title-format" />
					</tr>
					<tr>
						<xsl:for-each select="customer">
							<td xsl:use-attribute-sets="report-users-data-format">
								<xsl:for-each select="full-name">
									<xsl:call-template name="display_user_name" />
								</xsl:for-each>
							</td>
							<!-- generate a new row ever 3rd column -->
							<xsl:if test="((position() mod 3) = 0)">
								<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
							</xsl:if>
						</xsl:for-each>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the enabled commands for the user group -->
	<xsl:template name="detail_usergroup_enabledcmd_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<tr>
						<td xsl:use-attribute-sets="report-commands-title-format">
						Enabled Commands:
					</td>
						<td xsl:use-attribute-sets="report-commands-title-format" />
						<td xsl:use-attribute-sets="report-commands-title-format" />
						<td xsl:use-attribute-sets="report-commands-title-format" />
					</tr>
					<tr>
						<xsl:for-each select="enabled_commands">
							<xsl:for-each select="command">
								<td xsl:use-attribute-sets="report-commands-data-format">
									<xsl:apply-templates />
								</td>
								<!-- generate a new row ever 4th column -->
								<xsl:if test="((position() mod 4) = 0)">
									<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Displays the disabled commands for the user group-->
	<xsl:template name="detail_usergroup_disabledcmd_rows">
		<tr>
			<td>
				<table xsl:use-attribute-sets="report-detail-table-format">
					<tr>
						<td xsl:use-attribute-sets="report-commands-title-format">
						Disabled Commands:
					</td>
						<td xsl:use-attribute-sets="report-commands-title-format" />
						<td xsl:use-attribute-sets="report-commands-title-format" />
					</tr>
					<tr>
						<xsl:for-each select="disabled_commands">
							<xsl:for-each select="command">
								<td xsl:use-attribute-sets="report-commands-data-format">
									<xsl:apply-templates />
								</td>
								<!-- generate a new row ever 4th column -->
								<xsl:if test="((position() mod 4) = 0)">
									<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
					</tr>
				</table>
			</td>
		</tr>
	</xsl:template>

	<!-- Parses the user group elements in the XML data -->
	<xsl:template name="user_group">
		<xsl:for-each select="user_group">
			<table border="1" frame="above" width="100%">
				<xsl:call-template name="detail_usergroup_header_row" />
				<xsl:call-template name="detail_usergroup_detail_rows" />
				<xsl:call-template name="detail_usergroup_user_rows" />
				<xsl:call-template name="detail_usergroup_customer_rows" />
				<xsl:call-template name="detail_usergroup_enabledcmd_rows" />
				<xsl:call-template name="detail_usergroup_disabledcmd_rows" />
			</table>
			<xsl:if test="((ancestor::TestTrackData/include_page_breaks) and (position()!=last()))">
				<DIV style="page-break-after:always"></DIV>
				<xsl:call-template name="pageheader" />
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- Detail Report XML Parsing -->
	<xsl:template match="/">
		<html>
			<head>
				<xsl:call-template name="DefineStyles" />
			</head>
			<body>
				<xsl:for-each select="TestTrackData">
					<xsl:call-template name="pageheader" />
					<xsl:call-template name="user_group" />
				</xsl:for-each>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
